
Calculate Linux - Feature # 317: Ð—Ð°Ð³Ñ€ÑƒÐ·ÐºÐ° Ñ• LiveCD/LiveFlash Ð¿Ñ€Ð¸ Ð¸Ð½Ð¾Ð¼ Ñ€Ð°Ñ•Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð² Ñ•Ð¸Ñ•Ñ‚ÐµÑ‹

Status: New Priority: Normal

Author: ÐœÐ¸Ñ…Ð°Ð¸Ð» Ð“Ð°Ð³Ð°ÑƒÐ· Category: Calculate Linux

Created: 06/25/2011 Assignee: Mikhail Hiretsky

Updated: 08/24/2012 Due date:

Subject: Ð—Ð°Ð³Ñ€ÑƒÐ·ÐºÐ° Ñ• LiveCD/LiveFlash Ð¿Ñ€Ð¸ Ð¸Ð½Ð¾Ð¼ Ñ€Ð°Ñ•Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð² Ñ•Ð¸Ñ•Ñ‚ÐµÑ‹

Description: Ð”Ð°Ð²Ð½Ð¾ ÑƒÐ¶Ðµ Ð½Ðµ Ð²Ð¸Ð´ÐµÐ» Ñ„Ð»ÐµÑˆÐºÐ¸ Ð¼ÐµÐ½ÑŒÑˆÐµ 2G

Ð’ Ñ•Ð²Ñ•Ð·Ð¸ Ñ• Ñ•Ñ‚Ð¸Ð¼ Ð½Ð° Ñ•Ð²Ð¾ÐµÐ¹ Ñ„Ð»ÐµÑˆÐºÐµ Ñ…Ñ€Ð°Ð½ÑŽ 

Ð½ÐµÑ•ÐºÐ¾Ð»ÑŒÐºÐ¾ Ð²ÐµÑ€Ñ•Ð¸Ð¹ ÐºÐ°Ð»ÑŒÐºÐ¸ Ð² Ñ€Ð°Ð·Ð½Ñ‹Ñ… 

Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ñ•Ñ… Ñ•Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¼ Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð¼

<pre>

# ls -lA /mnt/cdrom/

Ð¸Ñ‚Ð¾Ð³Ð¾ 32

lrwxrwxrwx 1 root root     1 Ð•Ð¾Ñ• 13  2010 boot -> .

lrwxrwxrwx 1 root root    17 ÐœÐ°Ð¹ 12 17:58 CDS-11.3-i686 -> CDS-20110512-i686

dr-xr-xr-x 5 root root  4096 ÐœÐ°Ð¹ 12 14:08 CDS-20110512-i686

lrwxrwxrwx 1 root root    13 ÐœÐ°Ð¹ 12 17:59 CDS-i686 -> CDS-11.3-i686

lrwxrwxrwx 1 root root    18 ÐœÐ°Ð¹ 29 15:24 CLDG-11.6-i686 -> cldg-20110519-i686

dr-xr-xr-x 5 root root  4096 ÐœÐ°Ð¹ 19 12:59 cldg-20110519-i686

lrwxrwxrwx 1 root root    14 ÐœÐ°Ð¹ 29 15:24 CLDG-i686 -> CLDG-11.6-i686

drwxr-xr-x 2 root root  4096 Ð¡ÐµÐ½ 22  2010 grub

-rw-r--r-- 1 root root     9 Ð¯Ð½Ð² 20 01:02 livecd

drwx------ 2 root root 16384 ÐœÐ°Ð¹ 20 12:43 lost+found

# ls -lA /mnt/cdrom/cldg-20110519-i686/

Ð¸Ñ‚Ð¾Ð³Ð¾ 1390432

dr-xr-xr-x 2 root root       4096 ÐœÐ°Ð¹ 19 12:59 boot

dr-xr-xr-x 2 root root       4096 ÐœÐ°Ð¹ 19 12:59 isolinux

-r-xr-xr-x 1 root root          9 ÐœÐ°Ð¹ 19 12:59 livecd

-r-xr-xr-x 1 root root 1422389248 ÐœÐ°Ð¹ 19 12:59 livecd.squashfs

dr-xr-xr-x 2 root root       4096 ÐœÐ°Ð¹ 19 12:59 syslinux

# # Ð¢ÑƒÑ‚ Ð±Ð°Ð½Ð°Ð»ÑŒÐ½Ð¾ Ñ€Ð°Ñ•Ð¿Ð°ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ iso-Ð¾Ð±Ñ€Ð°Ð·Ñ‹ 

ÐºÐ°Ð»ÑŒÐºÐ¸

# cat /mnt/cdrom/livecd 

calculate

</pre>



Ñ•Ñ‚Ð¾ Ð¿Ð¾Ð·Ð²Ð¾Ð»Ñ•ÐµÑ‚ Ð·Ð°Ð³Ñ€ÑƒÐ¶Ð°Ñ‚ÑŒÑ•Ñ• Ñ• Ð¾Ð´Ð½Ð¾Ð¹ Ñ„Ð»ÐµÑˆÐºÐ¸ Ð² 

Ñ€Ð°Ð·Ð½Ñ‹Ðµ Ñ•Ð¸Ñ•Ñ‚ÐµÐ¼Ñ‹, Ð° Ñ‚Ð°ÐºÐ¶Ðµ (Ð² Ð¿ÐµÑ€Ñ•Ð¿ÐµÐºÑ‚Ð¸Ð²Ðµ) 

*ÑƒÐ¿Ñ€Ð¾Ñ‰Ð°ÐµÑ‚ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ•Ð¸Ñ•Ñ‚ÐµÐ¼Ñ‹ Ð½Ð° Ñ„Ð»ÐµÑˆÐºÐµ Ð¿Ñ€Ð¸ 

scratch-Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐµ* - Ð´Ð¾Ñ•Ñ‚Ð°Ñ‚Ð¾Ñ‡Ð½Ð¾ Ð±ÑƒÐ´ÐµÑ‚ ÑƒÐºÐ°Ð·Ð°Ñ‚ÑŒ 

Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸ÑŽ Ð½Ð° Ñ„Ð»ÐµÑˆÐºÐµ (Ðº Ð¿Ñ€Ð¸ÐµÑ€Ñƒ */mnt/flash/cldg-$(date 

'+%Y%m%d')-i686*) Ð² ÐºÐ¾Ñ‚Ð¾Ñ€ÑƒÑŽ Ñ•Ð¾Ð±Ð¸Ñ€Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¾Ð±Ñ€Ð°Ð· Ð¸ 

Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ•Ð¸Ð¼Ð»Ð¸Ð½Ðº Ð½Ð° Ð½ÐµÐµ (Ð² Ð´Ð°Ð½Ð½Ð¾Ð¼ Ñ•Ð»ÑƒÑ‡Ð°Ðµ ln 

--symbolic --force cldg-$(date '+%Y%m%d')-i686 /mnt/flash/CLDG-i686) Ð½Ðµ Ñ‚Ñ€Ð¾Ð³Ð°Ñ• 

ÐºÐ¾Ð½Ñ„Ð¸Ð³ grub-Ð°



ÐŸÑ€Ð¸ Ñ•Ñ‚Ð¾Ð¼ Ð²Ð¾Ð·Ð½Ð¸ÐºÐ°ÐµÑ‚ Ð´Ð²Ðµ Ñ‚Ñ€ÑƒÐ´Ð½Ð¾Ñ•Ð¸:

# Ð’ ÑƒÑ‚Ð¸Ð»Ð¸Ñ‚Ñƒ cl-install *Ð¿ÑƒÑ‚ÑŒ Ð´Ð¾ squash-Ñ„Ð°Ð¹Ð»Ð° Ð·Ð°Ð±Ð¸Ñ‚ Ð¶ÐµÑ•Ñ‚ÐºÐ¾*, 

Ñ‡Ñ‚Ð¾Ð± Ñ•Ñ‚Ð¾ Ð¿Ð¾Ð±Ð¾Ñ€Ð¾Ñ‚ÑŒ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¿ÑƒÑ‚ÑŒ Ð±Ñ€Ð°Ñ‚ÑŒ 

Ñ•Ð»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ¹ python-ÐºÐ¾Ð¼Ð°Ð½Ð´Ð¾Ð¹ <pre>filter((lambda x: 'loop=' == x[:5]) 

,open('/proc/cmdline').readline().split() )[0][5:]</pre>

Ð•Ðµ Ð¾Ñ•Ð¾Ð±Ð¾ Ð·Ð°Ð¼Ð¾Ñ€Ð°Ñ‡Ð¸Ð²Ð°Ñ•Ñ•ÑŒ Ð¾Ð±Ð¾ÑˆÐµÐ» Ñ•Ñ‚Ð¾ 
Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸Ðµ Ñ•Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¼ Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð¼<pre>mount -v --bind 

/mnt/cdrom/{CLDG-i686/,}</pre>

# ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ docache Ð½Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð°ÐµÑ‚.

Ð¡Ð²Ñ•Ð·Ð°Ð½Ð¾ Ñ•Ñ‚Ð¾ Ñ• Ñ‚ÐµÐ¼, Ñ‡Ñ‚Ð¾ Ñ•Ñ€ÐµÐ´Ð¸ Ð¿Ñ€Ð¾Ñ‡ÐµÐ³Ð¾ Ð² 

init-Ñ•ÐºÑ€Ð¸Ð¿Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¸Ñ•Ñ…Ð¾Ð´Ð¸Ñ‚ (Ð² Ð¼Ð¾ÐµÐ¼ Ñ•Ð»ÑƒÑ‡Ð°Ðµ) Ð¿Ð¾Ð¿Ñ‹Ñ‚ÐºÐ° 

Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ñ•Ð»ÐµÐ´ÑƒÑŽÑ‰ÐµÐµ

<pre>

cp -a ${NEW_ROOT}/mnt/cdrom/${LOOP} ${NEW_ROOT}/mnt/squash/${LOOP}

## Ñ‡Ñ‚Ð¾ Ñ€Ð°Ð²Ð½Ð¾Ñ•Ð¸Ð»ÑŒÐ½Ð¾

cp -a /newroot/mnt/cdrom//CLDG-i686/livecd.squashfs /mnt/squash//CLDG-i686/livecd.squashfs

</pre>

Ð¸ Ð¿Ð¾Ñ•ÐºÐ¾Ð»ÑŒÐºÑƒ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ð¸ /mnt/squash//CLDG-i686/ Ð¿Ð¾ÐºÐ° Ð½Ðµ 

Ñ•ÑƒÑ‰ÐµÑ•Ñ‚Ð²ÑƒÐµÑ‚, Ñ•Ñ‚Ð¾ Ð´ÐµÐ¹Ñ•Ñ‚Ð²Ð¸Ðµ Ð·Ð°ÐºÐ°Ð½Ñ‡Ð¸Ð²Ð°ÐµÑ‚Ñ•Ñ• 

Ð¾ÑˆÐ¸Ð±ÐºÐ¾Ð¹



Ð¡ Ñ•Ñ‚Ð¸Ð¼ Ð¿Ð¾Ð±Ð¾Ñ€Ð¾Ñ‚ÑŒÑ•Ñ• Ð½Ðµ Ð²Ð½Ð¾Ñ•Ñ• Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ• Ð² ÐºÐ¾Ð´ 

Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾Ñ•ÑŒ, Ñ‚Ð°Ðº Ñ‡Ñ‚Ð¾ Ð¿Ñ€Ð¸ÑˆÐ»Ð¾Ñ•ÑŒ Ñ•Ð»ÐµÐ³ÐºÐ° 

Ð¿Ð¾ÐºÐ¾Ð²Ñ‹Ñ€Ñ•Ñ‚ÑŒ genkernel/calckernel , Ñ€ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ñ‹ Ñ•Ñ‚Ð¾Ð³Ð¾ Ð¸ 

Ð²Ñ‹ÐºÐ»Ð°Ð´Ñ‹Ð²Ð°ÑŽ:

<pre>

# diff -su /usr/share/genkernel/defaults/initrd.scripts{_orig,}

--- /usr/share/genkernel/defaults/initrd.scripts_orig	2011-06-25 17:37:37.095401886 +0300

+++ /usr/share/genkernel/defaults/initrd.scripts	2011-06-25 18:33:34.302526754 +0300

@@ -210,10 +210,10 @@

 			if [[ $((${imagesize} + $addon)) -lt ${allmemory} ]];

 			then

 				mount -o remount,size=${addon}000 -t tmpfs tmpfs ${NEW_ROOT}

-				mkdir ${NEW_ROOT}/mnt/squash

-				mount -o size=${imagesize}000 -t tmpfs tmpfs ${NEW_ROOT}/mnt/squash

+				mkdir -pv "${NEW_ROOT}/mnt/squash/`dirname "${LOOP}"`"

+				mount -o size=${imagesize}000 -t tmpfs tmpfs "${NEW_ROOT}/mnt/squash/`dirname "${LOOP}"`"

 				good_msg "Copying loop file for caching..."

-				cp -a ${NEW_ROOT}/mnt/cdrom/${LOOP} ${NEW_ROOT}/mnt/squash/${LOOP}

+				cp -a "${NEW_ROOT}/mnt/cdrom/${LOOP}" "${NEW_ROOT}/mnt/squash/${LOOP}"

 				if [ $? -ne 0 ]

 				then

 					bad_msg "Failed to cache the loop file! Lack of space?"

</pre>

Ðš Ñ•Ð¾Ð¶Ð°Ð»ÐµÐ½Ð¸ÑŽ ÐŸÐžÐšÐ• Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ 

Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ñ•Ð¿Ð¾Ñ•Ð¾Ð±Ð½Ð¾Ñ•Ñ‚ÑŒ Ñ•Ñ‚Ð¾Ð³Ð¾ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚Ð° Ñ• Ð½Ðµ 

Ð¼Ð¾Ð³Ñƒ (Ð·Ð°Ð³Ñ€ÑƒÐ·Ð¸Ð»Ñ•Ñ• Ñ• Ñ‚Ð¾Ð¹ Ñ•Ð°Ð¼Ð¾Ð¹ Ñ„Ð»ÐµÑˆÐºÐ¸ Ð² Ð¾Ð±Ñ‹Ñ‡Ð½Ð¾Ð¼ 

Ñ€ÐµÐ¶Ð¸Ð¼Ðµ Ð¸ Ð¿Ð¾ÐºÐ° Ð¿ÐµÑ€ÐµÐ·Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒÑ•Ñ• Ð½ÐµÐ»ÑŒÐ·Ñ•), Ð½Ð¾ 

Ð²Ñ‹ÐºÐ»Ð°Ð´Ñ‹Ð²Ð°ÑŽ Ñ•ÑŽÐ´Ð° Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ (ÐºÐ°Ðº Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼ Ñ‡Ñ‚Ð¾Ð± Ð½Ðµ 

Ð¸Ð·Ð¾Ð±Ñ€ÐµÑ‚Ð°Ñ‚ÑŒ Ñ•Ñ‚Ð¸ Ð´Ð²Ðµ Ñ•Ñ‚Ñ€Ð¾ÐºÐ¸ Ð¿Ð¾Ð½Ð¾Ð²Ð¾Ð¼Ñƒ) Ñ‚.Ðº. 

ÑƒÐ²ÐµÑ€ÐµÐ½ Ð² ÐµÐ³Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ñ•Ð¿Ð¾Ñ•Ð¾Ð±Ð½Ð¾Ñ•Ñ‚Ð¸ Ð½Ð° 100%. Ð¢ÐµÐ¼ 

Ð½Ðµ Ð¼ÐµÐ½ÐµÐµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑŽ Ð¸ Ð¾Ñ‚Ð¿Ð¸ÑˆÑƒÑ•ÑŒ Ð¿Ð¾Ð½Ð¾Ð²Ð¾Ð¼Ñƒ.



PS

Ð½Ð° Ð²Ñ•Ñ•ÐºÐ¸Ð¹ Ñ•Ð»ÑƒÑ‡Ð°Ð¹ Ð¿Ñ€Ð¸ÐºÐ»Ð°Ð´Ñ‹Ð²Ð°ÑŽ ÐºÐ¾Ð½Ñ„Ð¸Ð³ grub-Ð° Ñ• 

Ð¼Ð¾ÐµÐ¹ Ñ„Ð»ÐµÑˆÐºÐ¸, Ñ‡Ñ‚Ð¾Ð± Ð±Ñ‹Ð»Ð¾ Ð¿Ð¾Ð½Ñ•Ñ‚Ð½ÐµÐµ Ð¾ Ñ‡ÐµÐ¼ 

Ñ€Ð°Ð·Ð³Ð¾Ð²Ð¾Ñ€.

History
06/28/2011 07:59 pm - ÐœÐ¸Ñ…Ð°Ð¸Ð» Ð“Ð°Ð³Ð°ÑƒÐ·

ÐŸÐžÐ§Ð¢Ð˜ Ð¾ÐºÐ°Ð·Ð°Ð»Ñ•Ñ• Ð¿Ñ€Ð°Ð².

Ðš Ñ•Ð¾Ð¶Ð°Ð»ÐµÐ½Ð¸ÑŽ *mkdir* Ð¸Ð· busybox Ð½Ðµ Ð·Ð½Ð°ÐµÑ‚ ÐºÐ»ÑŽÑ‡Ð° *-v* ÐŸÐ¾Ñ•Ñ‚Ð¾Ð¼Ñƒ Ð¿Ñ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ñ‹Ð¹ 

Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ Ñ‚Ð°ÐºÐ¾Ð¹

<pre><code class="diff"># diff -su /usr/share/genkernel/defaults/initrd.scripts{_orig,}

--- /usr/share/genkernel/defaults/initrd.scripts_orig   2011-06-28 18:48:17.000000000 +0300

+++ /usr/share/genkernel/defaults/initrd.scripts        2011-06-28 18:50:10.000000000 +0300

@@ -210,10 +210,10 @@

                        if [[ $((${imagesize} + $addon)) -lt ${allmemory} ]];

                        then

                                mount -o remount,size=${addon}000 -t tmpfs tmpfs ${NEW_ROOT}

-                               mkdir ${NEW_ROOT}/mnt/squash

-                               mount -o size=${imagesize}000 -t tmpfs tmpfs ${NEW_ROOT}/mnt/squash

+                               mkdir -p "${NEW_ROOT}/mnt/squash/`dirname "${LOOP}"`"

+                               mount -o size=${imagesize}000 -t tmpfs tmpfs "${NEW_ROOT}/mnt/squash/`dirname "${LOOP}"`"

                                good_msg "Copying loop file for caching..."

-                               cp -a ${NEW_ROOT}/mnt/cdrom/${LOOP} ${NEW_ROOT}/mnt/squash/${LOOP}

+                               cp -a "${NEW_ROOT}/mnt/cdrom/${LOOP}" "${NEW_ROOT}/mnt/squash/${LOOP}"

                                if [ $? -ne 0 ]

                                then

                                        bad_msg "Failed to cache the loop file! Lack of space?"

</code></pre>



Ð•Ð¾Ñ€Ð¼Ð°Ð»ÑŒÐ½Ð¾Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ðµ Ñ• CD Ñ•Ñ‚Ð¾ Ð½Ð¸ÐºÐ°Ðº Ð¿Ð¾Ð²Ñ€ÐµÐ´Ð¸Ñ‚ÑŒ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚, Ð»Ð¸ÑˆÑŒ 

Ñ€Ð°Ñ•ÑˆÐ¸Ñ€Ð¸Ñ‚ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾Ñ•Ñ‚Ð¸.

Ð’ Ñ•Ð²Ñ•Ð·Ð¸ Ñ• Ñ•Ñ‚Ð¸Ð¼ Ð¿Ñ€ÐµÐ´Ð»Ð°Ð³Ð°ÑŽ Ð²Ð½ÐµÑ•Ñ‚Ð¸ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ• Ð² Ð°Ð¿Ñ•Ñ‚Ñ€Ð¸Ð¼.

08/24/2012 10:06 am - Mikhail Hiretsky

- Assignee set to Mikhail Hiretsky
